"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var style_1 = require("./style");
function Footnote(options, renderer, children) {
    if (options.id) {
        return renderer.create("marker", { "data-footnote": true, "data-footnote-id": options.id }, children);
    }
    else {
        return renderer.create("marker", { "data-footnote": true }, children);
    }
}
exports.Footnote = Footnote;
function FootnoteBlock(options, renderer, children) {
    return renderer.create("marker", { "data-footnote": true, "data-footnote-block": true, "data-footnote-id": options.id }, children);
}
exports.FootnoteBlock = FootnoteBlock;
function Footnotes(_, renderer) {
    var classes = this.theme.classes(style_1.FootnoteStyle);
    return renderer.create("div", { "data-footnotes": true, class: classes.footnotes });
}
exports.Footnotes = Footnotes;
//# sourceMappingURL=index.js.map