"use strict";
function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
var meta_1 = require("./meta");
var fonts_1 = require("./fonts");
var footer_1 = require("./footer");
var header_1 = require("./header");
var style_1 = require("./style");
var watermark_1 = require("../misc/watermark");
function Page(options, renderer, content) {
    renderer = renderer.plug(this.theme.styled(style_1.PageStyle));
    return renderer.create("html", null,
        renderer.create("head", null,
            renderer.create("title", null, options.title || 'Codedoc Sample Page'),
            options.meta ? options.meta : renderer.create(meta_1.Meta, null),
            options.favicon ? renderer.create("link", { rel: "shortcut icon", href: options.favicon }) : '',
            options.fonts ? options.fonts : renderer.create(fonts_1.Fonts, null),
            options.scripts ? options.scripts : '',
            options.stylesheets ? options.stylesheets : ''),
        renderer.create("body", null,
            options.header ? options.header : renderer.create(header_1.Header, null,
                renderer.create(watermark_1.Watermark, null)),
            renderer.create("div", { id: "-codedoc-container", class: "container" }, content),
            options.toc ? options.toc : ' ',
            options.footer ? options.footer : renderer.create(footer_1.Footer, null)));
}
exports.Page = Page;
__export(require("./meta"));
__export(require("./fonts"));
__export(require("./contentnav"));
__export(require("./header"));
__export(require("./footer"));
__export(require("./toc"));
var style_2 = require("./style");
exports.PageStyle = style_2.PageStyle;
//# sourceMappingURL=index.js.map