import { ConfigOverride } from './override.type';
import { CodedocConfig } from './config.type';
import { Plugin } from './plugin';
export interface ConfigType extends ConfigOverride {
    plugins?: Plugin[];
}
/**
 *
 * Will create a codedoc configuration object (type `CodedocConfig`)
 * using the given config overrides. This will simply extend the default
 * configuration using given values in the overrides.
 *
 * @param override
 * @returns a complete codedoc configuration
 *
 */
export declare function configuration(override: ConfigType): CodedocConfig;
export * from './config.type';
export * from './override.type';
export * from './defaults';
export { Build } from './after-build.type';
